<template>
  <v-main @scroll="debouncedWatchScroll">
    <template v-for="message in messages" :key="message.messageId">
      <ChatMessage
        :class="message.who == username ? 'ml-10' : 'mr-10'"
        :message="message"
      />
    </template>
  </v-main>

  <form @submit.prevent="sendMessage()">
    <input
      type="text"
      placeholder="Type a message..."
      v-model="newMessage"
      maxlength="100"
    />
    <button type="submit" :disabled="!newMessage">💥</button>
  </form>
  <button v-if="unreadMessages" @click="autoScroll">💬</button>
</template>

<script setup lang="ts">
import ChatMessage from "./ChatMessage.vue";
import { onMounted, ref } from "vue";
import { username, user } from "../data/clients/user";
import debounce from "lodash.debounce";

import GUN, { SEA } from "gun";
const db = GUN();

let newMessage;
let messages = [];

let scrollBottom;
let lastScrollTop;
let canAutoScroll = true;
let unreadMessages = ref(false);

function autoScroll() {
  setTimeout(() => scrollBottom?.scrollIntoView({ behavior: "auto" }), 50);
  unreadMessages.value = false;
}

function watchScroll(e) {
  canAutoScroll = (e.target.scrollTop || Infinity) > lastScrollTop;
  lastScrollTop = e.target.scrollTop;
}

const debouncedWatchScroll = debounce(watchScroll, 1000);

onMounted(() => {
  var match = {
    // lexical queries are kind of like a limited RegEx or Glob.
    ".": {
      // property selector
      ">": new Date(+new Date() - 1 * 1000 * 60 * 60 * 3).toISOString(), // find any indexed property larger ~3 hours ago
    },
    "-": 1, // filter in reverse
  };

  // Get Messages
  db.get("chat")
    .map(match)
    .once(async (data, id) => {
      if (data) {
        // Key for end-to-end encryption
        const key = "#foo";

        var message = {
          // transform the data
          who: await db.user(data).get("alias"), // a user might lie who they are! So let the user system detect whose data it is.
          what: (await SEA.decrypt(data.what, key)) + "", // force decrypt as text.
          when: GUN.state.is(data, "what"), // get the internal timestamp for the what property.
        };

        if (message.what) {
          messages = [...messages.slice(-100), message].sort(
            (a, b) => a.when - b.when
          );
          if (canAutoScroll) {
            autoScroll();
          } else {
            unreadMessages.value = true;
          }
        }
      }
    });
});

async function sendMessage() {
  const secret = await SEA.encrypt(newMessage, "#foo");
  const message = user.get("all").set({ what: secret });
  const index = new Date().toISOString();
  db.get("chat").get(index).put(message);
  newMessage = "";
  canAutoScroll = true;
  autoScroll();
}
</script>
